// TestNewMat.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// TestNewmat.cpp 
// http://timebird.egloos.com/4688964

#define WANT_MATH 
#define WANT_STREAM 

#include "newmat.h" 
#include "newmatio.h" 

#ifdef use_namespace
using namespace RBD_LIBRARIES;
#endif

int _tmain(int argc, _TCHAR* argv[]) {
  double arr1 [] = { 
    0.85923654, 0.73141128, -1.3488804, 0.23961999, -0.74714014, 
    -1.3129133, -0.13301908, -2.2823553, 0.96488669, -0.13826908, 
    -0.52736826, 1.4513235, -0.58892330, 0.97566737, 0.0081871852, 
    0.37988831, -0.13753653, -0.41276399, -0.32645530, -0.016691520, 
    1.1030130, 0.18763227, 1.2025037, -0.72338246, 0.053477789 
  }; 
  double arr2 [] = { 
    0.90756273, 
    0.62986869, 
    -0.089942626, 
    -1.4125863, 
    -0.89115089 
  }; 

  Matrix ma(5,5); 
  ColumnVector ca(5); 
  ma = 0;  ca = 0;  // Initialize to zero all the elements 

  ma << arr1;  // Array of elements in the matrix is ??assigned 
  ca << arr2;  // Array element is assigned to a column vector 

  cout << "ma Matrix" << endl; 
  cout << ma << endl;  // Print matrix 
  cout << "ca ColumVector" << endl; 
  cout << ca << endl;  // Print the column vectors 

  Matrix mb; 
  double det_ma = ma.LogDeterminant ().Value ();  // Determinant wanted. 
  if (det_ma != 0.0) // check if the matrix is ??singular 
  { 
    mb = ma.i ();  // Singular inverse unless Wanted 
  } 
  cout << "ma of the inverse" << endl << mb << endl; 
  cout << "ma's transpose" << endl; 
  cout << ma.t() << endl; 

  cout << "ma * ca" << endl << ma * ca << endl; 
  return 0;
}

